=== examples/sysc/simple_bus/Makefile ===
include ../../build-unix/Makefile.config

PROJECT := simple_bus
SRCS    := $(wildcard *.cpp)
OBJS    := $(SRCS:.cpp=.o)

include ../../build-unix/Makefile.rules
