=== debian/changelog ===
systemc (2.3.3-5) unstable; urgency=medium

  * [e22977d] Update standards version to 4.5.0
  * [11acbf7] Set debhelper compat level in build deps.
    Bumped to compat level 12
  * [de2acf2] libsystemc.symbols: update after GCC-10 update.
    Thanks: Carsten Schoenert <c.schoenert@t-online.de> (Closes: #957856)

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Mon, 10 Aug 2020 11:07:17 +0200

systemc (2.3.3-4) unstable; urgency=medium

  [ أحمد المحمودي (Ahmed El-Mahmoudy) ]
  * [0ce80d7] Add gitlab-ci.yml
    Use the default GitLab CI from Salsa for package QA.

  [ Carsten Schoenert ]
  * [ad6f7c5] Revert "Switch to c++ symbols"
    Using filtered symbols isn't really helpful and extend the burden on
    maintaining the symbosl file.
  * [23c6b0d] libsystemc.symbols: update (again) after GCC update
    One more update to the symbols file after again a new GCC update.

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Tue, 20 Aug 2019 22:37:44 +0200

systemc (2.3.3-3) unstable; urgency=medium

  [ Carsten Schoenert ]
  * [dbc95a1] libsystemc.symbols: update after GCC update.
    As usual with every new GCC version we have changed symbol names,
    updating the symbols file for new GCC 9 in the archive.

  [ أحمد المحمودي (Ahmed El-Mahmoudy) ]
  * [fa74df1] Update standards version to 4.4.0, no changes needed
  * [c12d731] Switch to c++ symbols.
    Hoping that this would lessen the symbol changes for each gcc update

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Tue, 20 Aug 2019 05:30:06 +0200

systemc (2.3.3-2) unstable; urgency=medium

  [ أحمد المحمودي (Ahmed El-Mahmoudy) ]
  * [625f662] Revert "uscan: update watch file to catch new versions"
    This reverts commit 83ab9e15a4138b76fadd9d6ada5d0893a12f0ae8.
  * [3886a0b] Bumped standards version to 4.3.0, no changes needed

  [ Carsten Schoenert ]
  * [d3c60cd] libsystemc.symbols: update after GCC update

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Sun, 10 Mar 2019 07:04:08 +0100

systemc (2.3.3-1) unstable; urgency=medium

  [ Carsten Schoenert ]
  * [79d0b67] d/gbp.conf: adding config file for git-buildpackage
  * [14ad850] New upstream version 2.3.3
  * [4ec31b4] drop patch queue.
    Remove previous created patch about some fixing of typos, it's fixed
    upstream.
  * [efadac6] libsystemc.symbols: update file to version 2.3.3
  * [c408571] NOTICE: install file only within the -dev package.
    This is a fixup commit for d006443f5d6d3f508b8a889cfc4ce5624897b06e.
    The NOTICE file is a required supplement for the Apache License 2.0,
    which the systemc package is licensed.
  * [5dc45e5] d/README.source: adding some information about the source.
    Mainly some information about how to work with git-buildpackage.
    Gbp-Dch: Ignore
  * libsystemc-dev: decrease Architecture list. (Closes: #913269)
  * uscan: update watch file to catch new versions.
    Upstream isn't providing *.tar.gz files for Systemc, but plain gzip'd
    files. Updating file accordingly.

  [ أحمد المحمودي (Ahmed El-Mahmoudy) ]
  * [ccc8ac4] Install NOTICE file in libsystemc
  * [81a1b31] Update copyright info.

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Thu, 20 Dec 2018 10:28:41 +0100

systemc (2.3.2-3) unstable; urgency=medium

  [ أحمد المحمودي (Ahmed El-Mahmoudy) ]
  * Update standards version to 4.2.1, no changes needed
  * Limit build archs as per supported by upstream (Closes: #913269)
  * Re-added symbols file

  [ Carsten Schoenert ]
  * d/libsystemc.symbols: update symbols file. (Closes: #913270)
    After the using of g++-8 as the new default compiler some symbols have
    been changed. Adjust the files to reflect the new symbols.
    Also adding the field 'Build-Depends-Package'.
  * Lintian: update/remove lintian-override files.
    Lintian isn't complaining about the word 'Synopsys' anymore but is now
    telling some lintian-overrides are now useless. ;)
  * d/control: add Multi-Arch field on -doc package.
  * autopkgtest: add build-essential to Depends.
  * hardening: set DEB_BUILD_MAINT_OPTIONS for hardening

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Wed, 14 Nov 2018 10:19:23 +0100

systemc (2.3.2-2) unstable; urgency=medium

  * Updated standards version to 4.2.0
  * Remove symbols file, as it is a real pain to maintain

 -- أحمد المحمودي (Ahmed El-Mahmoudy) <aelmahmoudy@users.sourceforge.net>  Fri, 24 Aug 2018 13:12:46 +0200
