=== debian/watch ===
version=3
https://www.accellera.org/downloads/standards/systemc  .*systemc-?v?(\d[\d\.]*)\.tar\.gz
